{% set ente = instance_service.getCurrentInstance() %}
{% set class = message.visibility %}
{% set class = class ~ ((message.author and message.author.id == user.id) ? ' mine' : ' others') %}

{% set canViewDetails = is_granted('viewDetails', message) %}
<li class="mb-4 message">
  <div class="check-container">
    <div class="form-check">
      <input id="m-{{ message.id }}" class="checkbox-message" data-message-id="{{ message.id }}" type="checkbox" {% if request_integration_time and message.createdAt >= request_integration_time %}checked="checked"{% endif %}>
      <label for="m-{{ message.id }}" class="sr-only">{{ 'pratica.select_message' | trans}} {{ message.id }}</label>
    </div>
  </div>
  <div class="rounded p-3 shadow w-100 {{ class }}">
    <div class="message-header">
      <span class="avatar">
        <svg class="icon icon-secondary">
          <use xlink:href="/bootstrap-italia/dist/svg/sprite.svg#it-user"></use>
        </svg>
      </span>
      <span class="mx-2 text-secondary">
        <strong>
          {# Mosro il nome dell'ente se si tratta di un messaggio di sistema oppure sono cittadino e non sono l'autore del messaggio #}
          {% if not message.author or (user.id == pratica.user.id and message.author.id != user.id) %}
            {{ ente.name }}
          {% else %}
            {{ message.author.fullName }}
          {% endif %}
        </strong>
        {% if message.visibility == 'internal' %}
          <small> {{ 'operatori.messaggi.ha_aggiunto_nota_privata' | trans }}</small>
        {% endif %}
      </span>
    </div>

    <div class="message-body text-break">
      <small>{{ message.message|purify }}</small>
    {% if not message.readAt and
          ((user.id == pratica.user.id and
          (not message.author or message.author.id != user.id)) or
          (pratica.operatore and user.id == pratica.operatore.id and message.author and message.author.id == pratica.user.id)) %}
      {# Mostro il pixel di lettura se il messaggio non è stato ancora letto e se sono il cittadino e il messaggio è stato scritto dall'operatore oppure il messaggio è stato inviato dal cittadino e sono l' operatore che ha in carico la pratica #}
        <img class="d-none" src="{{ path('track_message', {'id':message.id}) }}">
      {% endif %}
    </div>

    {% if message.attachments|length > 0 %}
      <div class="mb-2">
        {% set download_allegato_path = user.id == pratica.user.id ? 'allegati_download_cpsuser' : 'allegati_download_operatore' %}
        {% for attachment in message.attachments %}
          <a class="mr-3" href="{{ path(download_allegato_path, {'allegato': attachment.id}) }}">
            <small class="text-break d-inline-flex align-items-center"><i class="fa fa-file mr-2"></i> {{ attachment.description }}</small>
          </a>
        {% endfor %}
      </div>
    {% endif %}

    <div class="row">
      <div class="col-12 text-right">
        {# mostra data di creazione/invio/lettura se l'autore del messaggio è l'utente che ha inviato il messaggio oppure se è un operatore che ha visibilità della pratica #}
        {% if canViewDetails %}
          <a data-toggle="collapse" data-target="#info_{{ message.id }}" aria-expanded="false"
             aria-controls="info_{{ message.id }}" role="button">
            <svg class="icon icon-xs">
              <use xlink:href="/bootstrap-italia/dist/svg/sprite.svg#it-info-circle"></use>
            </svg>
          </a>
          <small class="font-italic text-secondary">{{ message.createdAt|time_ago }}
            {% if message.readAt %}
              <span class="msg-status read"
                    title="{{ 'pratica.messaggio_letto'|trans }} {{ message.readAt | format_datetime('short', 'short', locale=app.request.locale) }}"></span>
            {% elseif message.sentAt %}
              <span class="msg-status"
                    title="{{ 'pratica.messaggio_creato'|trans }} {{ message.createdAt | format_datetime('short', 'short', locale=app.request.locale) }}"></span>
            {% else %}
              <span class="msg-status sent"
                    title="{{ 'pratica.messaggio_consegnato'|trans }} {{ message.sentAt | format_datetime('short', 'short', locale=app.request.locale) }}"></span>
            {% endif %}
          </small>
        {% endif %}
      </div>
    </div>

    {# Info del messaggio #}
    <div id="info_{{ message.id }}" class="collapse mt-1">
      {# mostra data di invio e lettura se l'autore del messaggio è l'utente che ha inviato il messaggio oppure se è un operatore che ha visibilità della pratica #}
      {% if canViewDetails %}
        <div class="row">
          <div class="col-6">
            <small class="font-weight-bold">{{ 'operatori.messaggi.inviato' | trans }}:</small>
          </div>
          <div class="col-6 text-right">
            <small>
              {{ message.sentAt ? message.sentAt|format_datetime('short', 'short', locale=app.request.locale) : '--' }}
            </small>
          </div>
        </div>
        <div class="row">
          <div class="col-6">
            <small class="font-weight-bold">{{ 'operatori.messaggi.letto' | trans }}:</small>
          </div>
          <div class="col-6 text-right">
            <small>
              {{ message.readAt ? message.readAt|format_datetime('short', 'short', locale=app.request.locale) : '--' }}
            </small>
          </div>
        </div>

        {# Mostro l'email a cui è stato inviato se l'autore non è il cittadino che ha inviato la pratica #}
        {% if (message.author and message.author.id != pratica.user.id) %}
          <div class="row">
            <div class="col-6">
              <small class="font-weight-bold">{{ 'operatori.messaggi.emails' | trans }}</small>
            </div>
            <div class="col-6 text-right">
              <small>
                {% if message.email %}
                  <a href="mailto:{{ message.email }}">{{ message.email }}</a>
                {% else %}
                  {{ 'operatori.messaggi.no_emails_info' | trans }}
                {% endif %}
              </small>
            </div>
          </div>
        {% endif %}
      {% endif %}
    </div>
  </div>
</li>
